Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class LazySortedMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.LazyMap
              org.apache.commons.collections.map.LazySortedMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map, java.util.SortedMap

    public class LazySortedMap

extends LazyMap
implements java.util.SortedMap

Decorates another `SortedMap` to create objects in the map on demand.

When the `LazyMap.get(Object)` method is called with a key that does not exist in the map, the factory is used to create the object. The created object will be added to the map using the requested key.

For instance:

     Factory factory = new Factory() {
         public Object create() {
             return new Date();
         }
     }
     SortedMap lazy = Lazy.sortedMap(new HashMap(), factory);
     Object obj = lazy.get("NOW");

After the above code is executed, `obj` will contain a new `Date` instance. Furthermore, that `Date` instance is mapped to the "NOW" key in the map.

Note that LazySortedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedSortedMap(java.util.SortedMap)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.LazyMap
`factory`

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` | `LazySortedMap(java.util.SortedMap map, Factory factory)` Constructor that wraps (not copies).
`protected` | `LazySortedMap(java.util.SortedMap map, Transformer factory)` Constructor that wraps (not copies).

Method Summary
`java.util.Comparator` | `comparator()`
`static java.util.SortedMap` | `decorate(java.util.SortedMap map, Factory factory)` Factory method to create a lazily instantiated sorted map.
`static java.util.SortedMap` | `decorate(java.util.SortedMap map, Transformer factory)` Factory method to create a lazily instantiated sorted map.
`java.lang.Object` | `firstKey()`
`protected java.util.SortedMap` | `getSortedMap()` Gets the map being decorated.
`java.util.SortedMap` | `headMap(java.lang.Object toKey)`
`java.lang.Object` | `lastKey()`
`java.util.SortedMap` | `subMap(java.lang.Object fromKey, java.lang.Object toKey)`
`java.util.SortedMap` | `tailMap(java.lang.Object fromKey)`

Methods inherited from class org.apache.commons.collections.map.LazyMap
`decorate, decorate, get`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### LazySortedMap

    protected LazySortedMap(java.util.SortedMap map,
                            Factory factory)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

### LazySortedMap

    protected LazySortedMap(java.util.SortedMap map,
                            Transformer factory)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

Method Detail

### decorate

    public static java.util.SortedMap decorate(java.util.SortedMap map,
                                               Factory factory)

  Factory method to create a lazily instantiated sorted map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

### decorate

    public static java.util.SortedMap decorate(java.util.SortedMap map,
                                               Transformer factory)

  Factory method to create a lazily instantiated sorted map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if map or factory is null

### getSortedMap

    protected java.util.SortedMap getSortedMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### firstKey

    public java.lang.Object firstKey()

  Specified by:
    `firstKey` in interface `java.util.SortedMap`

### lastKey

    public java.lang.Object lastKey()

  Specified by:
    `lastKey` in interface `java.util.SortedMap`

### comparator

    public java.util.Comparator comparator()

  Specified by:
    `comparator` in interface `java.util.SortedMap`

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Specified by:
    `subMap` in interface `java.util.SortedMap`

### headMap

    public java.util.SortedMap headMap(java.lang.Object toKey)

  Specified by:
    `headMap` in interface `java.util.SortedMap`

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object fromKey)

  Specified by:
    `tailMap` in interface `java.util.SortedMap`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.